/***********************************************************************/
/*                                                                     */
/*  FILE        :GYRO.c                                                */
/*  DATE        :Wed, Feb 11, 2009                                     */
/*  DESCRIPTION :Main Program                                          */
/*  CPU TYPE    :H8/3664F                                              */
/*                                                                     */
/*  This file is generated by KPIT GNU Project Generator.              */
/*  x@WCZT[                                           */
/*                                                                     */
/***********************************************************************/
                  
                  
#include "iodefine.h"
#include<stdio.h>

void init_rs232c(void);
void SendData(unsigned char data);
unsigned char ReciveData(void); 
void Test_EEPROM( unsigned char test_code  );
void wait( unsigned short limit );
unsigned char Read_page_EEPROM( unsigned short adrs , unsigned char *rd_ptr );
unsigned char Read_n_EEPROM( unsigned short adrs , unsigned char *rd_ptr , unsigned short no );
unsigned char Write_page_EEPROM( unsigned short adrs , unsigned char *wr_ptr );
unsigned char Read_byte_EEPROM( unsigned short adrs );
unsigned char Write_byte_EEPROM( unsigned short adrs , unsigned char wr_data );
/*---------------------------------------------------------------------------------------------------------*/
/*	IIC EEPROM Read/Write				*/
/*	Sub routine for H8/3664N built in EEPROM			*/
/*---------------------------------------------------------------------------------------------------------*/


#define DEVICE_CODE	0xa0			/* EEPROM DEVICE CODE:101 	*/
#define SLAVE_ADRS	0x02			/* SLAVE ADRS:1********************************************** 	*/
#define IIC_DATA_W	0x00			/* WRITE_DATA 	*/
#define IIC_DATA_R	0x01			/* READ_DAT 	*/

#define WR_RETRY_CNT	10			/* tWC(1ms)*10=10ms 	*/
#define WR_OK	11					/* loop break 	*/
#define EI()	asm volatile ("andc.b #0x7f,ccr")
#define DI()	asm volatile ("orc.b #0x80,ccr")

unsigned char	Write_data_EEPROM( unsigned char wr_data );
unsigned char	Set_adrs_EEPROM( unsigned short adrs );
unsigned char	Recv_data1_EEPROM( void );
unsigned char	Recv_datan_EEPROM( unsigned char *rd_ptr , unsigned short no );
void	wait_e( unsigned int loop);
void 	getadc(void);
unsigned int buf_wr[10];
unsigned int buf_rd[10];
char *p;
unsigned char test_code;
unsigned char dummy;
unsigned char n;
char out_data[10];
void itoa(char out_str[],unsigned int data);
int main(void)
{
  	unsigned char c;
  	unsigned char l;
  	unsigned char t;
    unsigned int cnt=0;
//	CPUCjVCY************************************************
	IO.PCR1 = 0x00;		 				//P1͓
	IO.PUCR1.BYTE = 0xFF;
	
	IO.PCR2 = 0x01;
	
  	IO.PUCR5.BYTE = 0x00;
	
	IO.PCR7 = 0x70;
	
  	IO.PCR8 = 0xDF; 					//bit5͓
	
	TA.TMA.BYTE = 0x1B;					//^C}[A31.25msec̃^Cx[XɂB
//	CPUCjVCY@I*****************************************

	buf_wr[6]=0;
	buf_wr[7]=0;
	
	
  	init_rs232c();  					//RS232C̏


	if(IO.PDR8.BIT.B5 == 0){
		SendData(0x0D);
		SendData(0x0A);
		SendData('S');
		SendData('T');
		SendData('A');
		SendData('R');
		SendData('T');
		SendData(0x0D);
		SendData(0x0A);
	
		for(cnt=0;cnt<65500;cnt += 16){
			Read_n_EEPROM(cnt,(char*)buf_rd,12);
			SendData(0x0D);
			SendData(0x0A);
			wait_e(2000);
			for(c=0;c<6;c++){
				itoa(out_data,buf_rd[c]);
				for(n=0;n<5;n++){
    				SendData(out_data[n]);
				}
				SendData(0x09);		//^uR[hFGNZ̃Z؂
			}
		}
		SendData(0x0D);
		SendData(0x0A);
		SendData('E');
		SendData('N');
		SendData('D');
		SendData(0x0D);
		SendData(0x0A);
		while(1);
	}
	
	while(IO.PDR8.BIT.B5 == 1)
			;
	wait_e(1000);
	while(IO.PDR8.BIT.B5 == 1)
			;
	EI();
	IENR1.BYTE = 0x50;					//TimerA荞
	while(1){
	}
	
}
//------------- Main End ------------------------------------------
//-----------------------------------------------------------------


/*---------------------------------------------------------------------------------------------------------*/
/*	Read_page_EEPROM	(8byte)				                                           */
/*	Argument1: Read address(unsigned short)			                                           */
/*	Argument2: Storing read data address (unsigned char *)		                                   */
/*	Return value: 1: OK / 0: NG EEPROM NOACK(unsigned char)		                                   */
/*---------------------------------------------------------------------------------------------------------*/
unsigned char Read_page_EEPROM( unsigned short adrs , unsigned char *rd_ptr ) {
unsigned char	i,ack;

IIC.ICCR.BYTE = 0x89;				/* ICE=1 P57,P56->SCL,SDA 	*/
IIC.ICMR.BYTE = 0x08;
TSCR.BYTE = 0xfc;

ack = 0;
while (IIC.ICCR.BIT.BBSY != 0)			/* Bus busy? 	*/
;

ack = Set_adrs_EEPROM(adrs);			/* Addressing(dummy write)	*/
if (ack == 0)	{
IIC.ICCR.BIT.IRIC = 0;
IIC.ICCR.BYTE = IIC.ICCR.BYTE & 0xfa;			/* Generate stop condition 	*/
return(0);
}

ack = Recv_datan_EEPROM(rd_ptr,8);			/* Data reading of 8 bytes 	*/

return(ack);
}

/*---------------------------------------------------------------------------------------------------------*/
/*	Read_page_EEPROM	(n byte)				                                           */
/*	Argument1: Read address (unsigned short)			                                   */
/*	Argument2: Storing read data address (unsigned char *)		                                   */
/*	Argument3: Number of read data (unsigned short)			                                   */
/*	Return value: 1: OK / 0: NG EEPROM NOACK(unsigned char)		                                   */
/*---------------------------------------------------------------------------------------------------------*/
unsigned char Read_n_EEPROM( unsigned short adrs , unsigned char *rd_ptr , unsigned short no ) {
unsigned char	i,ack;

IIC.ICCR.BYTE = 0x89;				/* ICE=1 P57,P56->SCL,SDA 	*/
IIC.ICMR.BYTE = 0x08;
TSCR.BYTE = 0xfc;

ack = 0;
while (IIC.ICCR.BIT.BBSY != 0)			/* Bus busy? 	*/
;

ack = Set_adrs_EEPROM(adrs);			/* Addressing (dummy write) 	*/
if (ack == 0) {
IIC.ICCR.BIT.IRIC = 0;
IIC.ICCR.BYTE = IIC.ICCR.BYTE & 0xfa;			/* Generate stop condition 	*/
return(0);
}

ack = Recv_datan_EEPROM(rd_ptr,no);			/* Data reading of n bytes 	*/

return(ack);
}
/*---------------------------------------------------------------------------------------------------------*/
/*	Write_page_EEPROM	(8byte)				                                           */
/*	Argument1: Write address (unsigned short)			                                   */
/*	Argument2: Storing write data address (unsigned char *)		                                   */
/*	Return value: 1: OK / 0: NG EEPROM NOACK(unsigned char)		                                   */
/*---------------------------------------------------------------------------------------------------------*/
unsigned char Write_page_EEPROM( unsigned short adrs , unsigned char *wr_ptr ) {
unsigned char	loop,i,ack;

ack = 0;
loop = 0;
while (loop <= WR_RETRY_CNT) {
IIC.ICCR.BYTE = 0x89;				/* ICE=1(P57,P56->SCL,SDA) 	*/
IIC.ICMR.BYTE = 0x08;
TSCR.BYTE = 0xfc;

while (IIC.ICCR.BIT.BBSY != 0)			/* Bus busy? 	*/
;

ack = Set_adrs_EEPROM(adrs);			/* Addressing 	*/
if ( ack == 1 ) {
loop = WR_OK;
}
else {
IIC.ICCR.BIT.IRIC = 0;
IIC.ICCR.BYTE = IIC.ICCR.BYTE & 0xfa;			/* Generation of stop condition 	*/
wait_e(1000);				/* tWC=1ms 	*/
loop++;
}
}

if (ack == 1) {
IIC.ICCR.BIT.IRIC = 0;
i = 0;
while ((i < 8) && (ack == 1)) {
ack = Write_data_EEPROM(*wr_ptr);			/* Writing of data of 8 bytes 	*/
wr_ptr++;
i++;
}
IIC.ICCR.BIT.IRIC = 0;
IIC.ICCR.BYTE = IIC.ICCR.BYTE & 0xfa;			/* Generation of stop condition 	*/
}

return(ack);
}
/*---------------------------------------------------------------------------------------------------------*/
/*	wait_e (Wait sub routine for EEPROM)			                                           */
/*	Argument1: Number of loops (unsigned short)			                                   */
/*	Return value: None					                                           */
/*---------------------------------------------------------------------------------------------------------*/
void wait_e( unsigned int loop) {
volatile unsigned int	i;

for (i=0;i < loop;i++) {
dummy++;
}
}

/*---------------------------------------------------------------------------------------------------------*/
/*	Read_byte_EEPROM					                                           */
/*	Argument1: Read address (unsigned short)			                                   */
/*	Return value: Read data (unsigned char)			                                           */
/*---------------------------------------------------------------------------------------------------------*/
unsigned char Read_byte_EEPROM( unsigned short adrs ) {
unsigned char	data=0xff,ack=0;

IIC.ICCR.BYTE = 0x89;				/* ICE=1 P57,P56->SCL,SDA 	*/
IIC.ICMR.BYTE = 0x08;
TSCR.BYTE = 0xfc;

while (IIC.ICCR.BIT.BBSY != 0)			/* Bus busy? 	*/
;

ack = Set_adrs_EEPROM(adrs);			/* Addressing (dummy write)	*/

if (ack == 1)	{
data = Recv_data1_EEPROM();
}

IIC.ICCR.BIT.IRIC = 0;
IIC.ICCR.BYTE = IIC.ICCR.BYTE & 0xfa;			/* Generate stop condition	 */

return(data);
}
/*---------------------------------------------------------------------------------------------------------*/
/*	Write_byte_EEPROM					                                           */
/*	Argument1: Write address (unsigned short)			                                   */
/*	Argument2: Write data (unsigned char)			                                           */
/*	Return value: 1: OK / 0: NG EEPROM NOACK(unsigned char)		                                   */
/*---------------------------------------------------------------------------------------------------------*/
unsigned char Write_byte_EEPROM( unsigned short adrs , unsigned char wr_data ) {
unsigned char	loop,ack;

ack = 0;
loop = 0;
while (loop <= WR_RETRY_CNT) {

IIC.ICCR.BYTE = 0x89;				/* ICE=1(P57,P56->SCL,SDA) 	*/
IIC.ICMR.BYTE = 0x08;
TSCR.BYTE = 0xfc;

while (IIC.ICCR.BIT.BBSY != 0)			/* Bus busy? 	*/
;

ack = Set_adrs_EEPROM(adrs);
if ( ack == 1 ) {
loop = WR_OK;
}

else {
IIC.ICCR.BIT.IRIC = 0;
IIC.ICCR.BYTE = IIC.ICCR.BYTE & 0xfa;			/* Generate stop condition	 */
wait_e(1000);				/* tWC=1ms 	*/
loop++;
}
}

if (ack == 1) {
ack = Write_data_EEPROM(wr_data);
IIC.ICCR.BIT.IRIC = 0;
IIC.ICCR.BYTE = IIC.ICCR.BYTE & 0xfa;			/* Generate stop condition 	*/
}

return(ack);
}

/*---------------------------------------------------------------------------------------------------------*/
/*	Write_data_EEPROM					                                           */
/*	Argument1: Write address (unsigned short)			                                   */
/*	Return value: 1: OK / 0: NG EEPROM NOACK(unsigned char)		                                   */
/*---------------------------------------------------------------------------------------------------------*/
/*---------------------------------------------------------------------------------------------------------*/
/*  (BYTE WRITE ACTION)					                                                   */
/*			  <4>      				                                           */
/*			  123456789				                                           */
/*			  000000000				                                           */
/*			  Write data A			                                                   */
/*---------------------------------------------------------------------------------------------------------*/
unsigned char Write_data_EEPROM( unsigned char wr_data ) {

						/* <4> 	*/
IIC.ICDR = wr_data;				/* <4> Set writing data 	*/
IIC.ICCR.BIT.IRIC = 0;
while (IIC.ICCR.BIT.IRIC == 0)			/* <4> Transmission complete? 	*/
;
if ( IIC.ICSR.BIT.ACKB != 0 ) {			/* ACK? 	*/
return(0);
}

return(1);
}

/*---------------------------------------------------------------------------------------------------------*/
/*	Set_adrs_EEPROM					                                                   */
/*	Argument1: Write / read address (unsigned short)		                                   */
/*	Return value: 1: OK / 0: NG EEPROM NOACK(unsigned char)		                                   */
/*---------------------------------------------------------------------------------------------------------*/
/*---------------------------------------------------------------------------------------------------------*/
/*  ADDRESS SET ACTION / DUMMY WRITE ACTION) 			                                           */
/*  <1>		<2> 	<3>			                                                           */
/*  123456789 	123456789 	123456789 			                                           */
/*  101000000 	000000000 	000000000 			                                           */
/*  Slave WA 	Address HI A 	Address LO A 			                                           */
/*---------------------------------------------------------------------------------------------------------*/
unsigned char Set_adrs_EEPROM( unsigned short adrs ) {
unsigned char	ret;

IIC.ICCR.BYTE |= 0x30;			/* Master transmission setting (MST=1,TRS=1) 	*/
IIC.ICCR.BYTE = ((IIC.ICCR.BYTE & 0xfe) | 0x04);
					/* Generating of start condition 	*/
while (IIC.ICCR.BIT.IRIC == 0)		/* Transmission OK? 		*/
;
					/* <1> 		*/
IIC.ICDR = (unsigned char)(DEVICE_CODE | SLAVE_ADRS | IIC_DATA_W);
					/* <1>Slave address set 	*/
IIC.ICCR.BIT.IRIC = 0;

while (IIC.ICCR.BIT.IRIC == 0)		/* <1> Transmission complete? 	*/
;

if ( IIC.ICSR.BIT.ACKB != 0 ) {		/* ACK? 		*/
return(0);
}
					/* <2> 		*/
IIC.ICDR = (unsigned char)(adrs >> 8);		/* <2> Upper address set 	*/
IIC.ICCR.BIT.IRIC = 0;
while (IIC.ICCR.BIT.IRIC == 0)		/* <2> Transmission complete? 	*/
;
if ( IIC.ICSR.BIT.ACKB != 0 ) {		/* ACK? 	*/
	return(0);
}
					/* <3> 		*/
IIC.ICDR = (unsigned char)(adrs & 0x00ff);	/* <3> Lower address set 	*/
IIC.ICCR.BIT.IRIC = 0;
while (IIC.ICCR.BIT.IRIC == 0)		/* <3> Transmission complete? 	*/
;

if ( IIC.ICSR.BIT.ACKB != 0 ) {			/* ACK? 	*/
return(0);
}

return(1);
}

/*---------------------------------------------------------------------------------------------------------*/
/*	Recv_data1_EEPROM					                                           */
/*	Return value: Read data (unsigned char)			                                           */
/*---------------------------------------------------------------------------------------------------------*/
/*---------------------------------------------------------------------------------------------------------*/
/*  (CURRENT ADDRESS READ ACTION)				                                           */
/*  <1>		<2>      				                                                   */
/*  123456789 	123456789				                                                   */
/*  101000010 	000000000				                                                   */
/*  Slave RA 	Read data A				                                                   */
/*---------------------------------------------------------------------------------------------------------*/
unsigned char Recv_data1_EEPROM( void ) {
unsigned char	recv;

IIC.ICCR.BYTE |= 0x30;			/* Master transmission setting (MST=1,TRS=1) 	*/
IIC.ICCR.BYTE = ((IIC.ICCR.BYTE & 0xfe) | 0x04);
					/* Generating of start condition 	*/
while (IIC.ICCR.BIT.IRIC == 0)		/* Transmission OK? 		*/
;

IIC.ICDR = (unsigned char)(DEVICE_CODE | SLAVE_ADRS | IIC_DATA_R);
					/* <1> Slave address set 	*/
IIC.ICCR.BIT.IRIC = 0;

while (IIC.ICCR.BIT.IRIC == 0)		/* <1> Transmission complete? 	*/
;
if ( IIC.ICSR.BIT.ACKB != 0 ) {		/* ACK? 		*/
return(0);
}

wait_e(30);				/* dummy wait 		*/
					/* Master reception setting 	*/
IIC.ICCR.BIT.TRS = 0;
IIC.ICMR.BIT.WAIT = 1;
IIC.ICSR.BIT.ACKB = 0;

recv = IIC.ICDR;				/* dummy read 	*/
IIC.ICCR.BIT.IRIC = 0;

while (IIC.ICCR.BIT.IRIC == 0)			/* Reception complete? 	*/
;

						/* < The last reception > 	*/
IIC.ICSR.BIT.ACKB = 1;
IIC.ICCR.BIT.TRS = 1;
IIC.ICCR.BIT.IRIC = 0;
while (IIC.ICCR.BIT.IRIC == 0)			/* Reception complete? 	*/
;

IIC.ICMR.BIT.WAIT = 0;

recv = IIC.ICDR;				/* Received data read 	*/

return(recv);
}
/*--------------------------------------------------------------------------------------------------------*/
/*	Recv_datan_EEPROM					                                           */
/*	Argument1: Storing read data address (unsigned char *)		                                   */
/*	Argument2: Read byte number1-512 (unsigned char)		                                   */
/*	Return value: 1: OK / 0: NG EEPROM NOACK (unsigned char)		                           */
/*---------------------------------------------------------------------------------------------------------*/
/*---------------------------------------------------------------------------------------------------------*/
/*  (CURRENT ADDRESS READ ACTION)				                                           */
/*  <1>		<2>	<3>	<n>      		                                                   */
/*  123456789 	123456789 	123456789   	123456789		                                   */
/*  101000010 	000000000 	000000000   	000000000		                                   */
/*  Slave RA 	Read data A 	Read data A   Read data A		                                   */
/*---------------------------------------------------------------------------------------------------------*/
unsigned char Recv_datan_EEPROM( unsigned char *rd_ptr , unsigned short no ) {
unsigned char	recv;

IIC.ICCR.BYTE |= 0x30;				/* Master transmission setting (MST=1,TRS=1) */
IIC.ICCR.BYTE = ((IIC.ICCR.BYTE & 0xfe) | 0x04);
					/* Generating of start condition 	*/
while (IIC.ICCR.BIT.IRIC == 0)		/* Transmission OK? 		*/
;

IIC.ICDR = (unsigned char)(DEVICE_CODE | SLAVE_ADRS | IIC_DATA_R);
					/* <1> Slave address set	*/
IIC.ICCR.BIT.IRIC = 0;

while (IIC.ICCR.BIT.IRIC == 0)		/* <1> Transmission complete? 	*/
;

if ( IIC.ICSR.BIT.ACKB != 0 ) {		/* ACK? 		*/
return(0);
}

wait_e(30);				/* dummy wait 		*/
					/* Master reception setting 	*/
IIC.ICCR.BIT.TRS = 0;
IIC.ICMR.BIT.WAIT = 1;
IIC.ICSR.BIT.ACKB = 0;

recv = IIC.ICDR;			/* dummy read 		*/
IIC.ICCR.BIT.IRIC = 0;
while (IIC.ICCR.BIT.IRIC == 0)		/* Reception complete? 	*/
;

IIC.ICCR.BIT.IRIC = 0;

while (1 < no) {
while (IIC.ICCR.BIT.IRIC == 0)		/* Reception complete? 	*/
;

*rd_ptr = IIC.ICDR;			/* Received data read 	*/

IIC.ICCR.BIT.IRIC = 0;
while (IIC.ICCR.BIT.IRIC == 0)		/* Reception complete?	*/
;

rd_ptr++;				/* Storage address increment 	*/
no--;
if (1 < no) {
IIC.ICCR.BIT.IRIC = 0;
}
}

					/* < The last reception >	*/
IIC.ICSR.BIT.ACKB = 1;
IIC.ICCR.BIT.TRS = 1;

IIC.ICCR.BIT.IRIC = 0;
while (IIC.ICCR.BIT.IRIC == 0)		/* Reception complete? 	*/
;

IIC.ICMR.BIT.WAIT = 0;

*rd_ptr = IIC.ICDR;			/* Received data read 	*/

IIC.ICCR.BIT.IRIC = 0;

IIC.ICCR.BYTE = IIC.ICCR.BYTE & 0xfa;		/* Generation of stop condition 	*/

return(1);
}


/*-------------------------------------------------------------------------------------*/
/*	EEPROM Read/Write End					                                           */
/*-------------------------------------------------------------------------------------*/

//**************************************************************************************
//--------------------------------------------------------------------------------------
//RS232C̏@M
//**************************************************************************************

void init_rs232c(void)
{
  volatile int t;

  IO.PMR1.BYTE = 0x02;         			//P22[qTXDɕύX
  SCI3.SCR3.BYTE &= 0x00;         		//l̂܂܁iTE,RE0A{[CgIA݂Ȃj
  SCI3.SMR.BYTE = 0x00;           		//l̂܂܁i,8bit,no parity,1 stop bit,NbNȂj
  SCI3.BRR = 51;             			//9600bpsi2000sŎ肱ڂFG[ĂȂj
  for(t=0;t<5000;t++);    				//1bitMԂ蒷҂
  SCI3.SCR3.BYTE |= 0x30;         		//MJnibit4FMF񖢎gpAbit5FMj
}

//1byteM
void SendData(unsigned char data)
{
  while(SCI3.SSR.BIT.TDRE == 0)		 	//f[^MȂ҂
  	;
  SCI3.TDR = data;               		//Mf[^Zbg
}

//1byteM
unsigned char ReciveData(void)
{
  do {
    if( (SCI3.SSR.BYTE & 0x38) != 0) {	//bit3:peB[,4:t[~O,5:I[o[̊eG[
      //G[
      SCI3.SSR.BYTE &= 0xc7;        	//G[tÕNA
      return 0xff;              		//G[0xFFԂ
    }
  } while(SCI3.SSR.BIT.RDRF == 0)	   	//f[^M܂őҋ@iMf[^ȂƌnOAbvj
  	;

  return SCI3.RDR;                 		//f[^̎M
}

//****************************************************************************
//	A/Df[^Textɕϊ : void itoa(char *,unsigned int)
//	int^Ȃ̂5̗pӂ邪4Lf[^͖iA/D10bitj	 
//****************************************************************************
void itoa(char out_str[],unsigned int data){
	int i,shyo,flag;
	flag = 0;

	for (i = 10000;i >= 1;i = i/10){
		shyo = (char)(data/i);
		data = data%i;
		if(shyo != 0 || flag != 0){
			*(out_str++) = shyo + '0';
			flag = 1;
		}
		else if(i >= 10){				//10ʂ܂ł0\Ȃi00450->  450)
			*(out_str++) = ' ';
		}
		else {
			*(out_str++) = '0';			//l"0"1ʂ̂0\B
		}
	}
	*out_str = '\0';					//̏IĩvOł͕svFgpj
}

//****************************************************************************
//   Function Name : getadc(unsigned int *adc_data) 
//   Title         : Get A/D Converter  
//****************************************************************************
void getadc()
{

// ------ CH0 ------
	AD.ADCSR.BYTE = 0x20; /* get AN(0)*/
    while(AD.ADCSR.BIT.ADF ==0)
			;
	  	buf_wr[1]= AD.ADDRA >> 6; /* get AN(0)*/
	  	AD.ADCSR.BIT.ADF = 0;
		
// ------ CH1 ---------
	AD.ADCSR.BYTE = 0x21; /* get AN(1)*/
    while(AD.ADCSR.BIT.ADF ==0)
			;
		buf_wr[2]= AD.ADDRB >> 6; /* get AN(1)*/
	  	AD.ADCSR.BIT.ADF = 0;

// ------ CH2 ---------
	AD.ADCSR.BYTE = 0x22; /* get AN(2)*/
    while(AD.ADCSR.BIT.ADF ==0)
			;
	  	buf_wr[3]= AD.ADDRC >> 6; /* get AN(2)*/
	  	AD.ADCSR.BIT.ADF = 0;

// ------ CH3 ---------
	AD.ADCSR.BYTE = 0x23; /* get AN(3)*/
    while(AD.ADCSR.BIT.ADF ==0)
			;
	  	buf_wr[4]= AD.ADDRD >> 6; /* get AN(3)*/
	  	AD.ADCSR.BIT.ADF = 0;
	  
// ------ CH4 ---------
	AD.ADCSR.BYTE = 0x24; /* get AN(4)*/
    while(AD.ADCSR.BIT.ADF ==0)
			;
	  	buf_wr[5]= AD.ADDRA >> 6; /* get AN(4)*/
	  	AD.ADCSR.BIT.ADF = 0;
	  		
}

